<?php

/**
 * Base static class for performing query and update operations on the 'katao_invoice' table.
 *
 * 
 *
 * @package    lib.model.om
 */
abstract class BaseKataoInvoicePeer {

	/** the default database name for this class */
	const DATABASE_NAME = 'propel';

	/** the table name for this class */
	const TABLE_NAME = 'katao_invoice';

	/** A class that can be returned by this peer. */
	const CLASS_DEFAULT = 'lib.model.KataoInvoice';

	/** The total number of columns. */
	const NUM_COLUMNS = 21;

	/** The number of lazy-loaded columns. */
	const NUM_LAZY_LOAD_COLUMNS = 0;


	/** the column name for the ID field */
	const ID = 'katao_invoice.ID';

	/** the column name for the KATAO_MEMBER_ID field */
	const KATAO_MEMBER_ID = 'katao_invoice.KATAO_MEMBER_ID';

	/** the column name for the KATAO_PERIOD_ID field */
	const KATAO_PERIOD_ID = 'katao_invoice.KATAO_PERIOD_ID';

	/** the column name for the KATAO_NODE_ID field */
	const KATAO_NODE_ID = 'katao_invoice.KATAO_NODE_ID';

	/** the column name for the KATAO_CART_ID field */
	const KATAO_CART_ID = 'katao_invoice.KATAO_CART_ID';

	/** the column name for the STATUS field */
	const STATUS = 'katao_invoice.STATUS';

	/** the column name for the MEMBER_FIRST_NAME field */
	const MEMBER_FIRST_NAME = 'katao_invoice.MEMBER_FIRST_NAME';

	/** the column name for the MEMBER_LAST_NAME field */
	const MEMBER_LAST_NAME = 'katao_invoice.MEMBER_LAST_NAME';

	/** the column name for the MEMBER_EMAIL field */
	const MEMBER_EMAIL = 'katao_invoice.MEMBER_EMAIL';

	/** the column name for the MEMBER_ADDRESS1 field */
	const MEMBER_ADDRESS1 = 'katao_invoice.MEMBER_ADDRESS1';

	/** the column name for the MEMBER_ADDRESS2 field */
	const MEMBER_ADDRESS2 = 'katao_invoice.MEMBER_ADDRESS2';

	/** the column name for the MEMBER_ZIP field */
	const MEMBER_ZIP = 'katao_invoice.MEMBER_ZIP';

	/** the column name for the MEMBER_CITY field */
	const MEMBER_CITY = 'katao_invoice.MEMBER_CITY';

	/** the column name for the KATAO_NAME field */
	const KATAO_NAME = 'katao_invoice.KATAO_NAME';

	/** the column name for the KATAO_ADDRESS field */
	const KATAO_ADDRESS = 'katao_invoice.KATAO_ADDRESS';

	/** the column name for the KATAO_SIRET_NUMBER field */
	const KATAO_SIRET_NUMBER = 'katao_invoice.KATAO_SIRET_NUMBER';

	/** the column name for the KATAO_RCS_NUMBER field */
	const KATAO_RCS_NUMBER = 'katao_invoice.KATAO_RCS_NUMBER';

	/** the column name for the KATAO_CAPITAL field */
	const KATAO_CAPITAL = 'katao_invoice.KATAO_CAPITAL';

	/** the column name for the SOL_AMOUNT field */
	const SOL_AMOUNT = 'katao_invoice.SOL_AMOUNT';

	/** the column name for the CREATED_AT field */
	const CREATED_AT = 'katao_invoice.CREATED_AT';

	/** the column name for the UPDATED_AT field */
	const UPDATED_AT = 'katao_invoice.UPDATED_AT';

	/** The PHP to DB Name Mapping */
	private static $phpNameMap = null;


	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'KataoMemberId', 'KataoPeriodId', 'KataoNodeId', 'KataoCartId', 'Status', 'MemberFirstName', 'MemberLastName', 'MemberEmail', 'MemberAddress1', 'MemberAddress2', 'MemberZip', 'MemberCity', 'KataoName', 'KataoAddress', 'KataoSiretNumber', 'KataoRcsNumber', 'KataoCapital', 'SolAmount', 'CreatedAt', 'UpdatedAt', ),
		BasePeer::TYPE_COLNAME => array (KataoInvoicePeer::ID, KataoInvoicePeer::KATAO_MEMBER_ID, KataoInvoicePeer::KATAO_PERIOD_ID, KataoInvoicePeer::KATAO_NODE_ID, KataoInvoicePeer::KATAO_CART_ID, KataoInvoicePeer::STATUS, KataoInvoicePeer::MEMBER_FIRST_NAME, KataoInvoicePeer::MEMBER_LAST_NAME, KataoInvoicePeer::MEMBER_EMAIL, KataoInvoicePeer::MEMBER_ADDRESS1, KataoInvoicePeer::MEMBER_ADDRESS2, KataoInvoicePeer::MEMBER_ZIP, KataoInvoicePeer::MEMBER_CITY, KataoInvoicePeer::KATAO_NAME, KataoInvoicePeer::KATAO_ADDRESS, KataoInvoicePeer::KATAO_SIRET_NUMBER, KataoInvoicePeer::KATAO_RCS_NUMBER, KataoInvoicePeer::KATAO_CAPITAL, KataoInvoicePeer::SOL_AMOUNT, KataoInvoicePeer::CREATED_AT, KataoInvoicePeer::UPDATED_AT, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'katao_member_id', 'katao_period_id', 'katao_node_id', 'katao_cart_id', 'status', 'member_first_name', 'member_last_name', 'member_email', 'member_address1', 'member_address2', 'member_zip', 'member_city', 'katao_name', 'katao_address', 'katao_siret_number', 'katao_rcs_number', 'katao_capital', 'sol_amount', 'created_at', 'updated_at', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'KataoMemberId' => 1, 'KataoPeriodId' => 2, 'KataoNodeId' => 3, 'KataoCartId' => 4, 'Status' => 5, 'MemberFirstName' => 6, 'MemberLastName' => 7, 'MemberEmail' => 8, 'MemberAddress1' => 9, 'MemberAddress2' => 10, 'MemberZip' => 11, 'MemberCity' => 12, 'KataoName' => 13, 'KataoAddress' => 14, 'KataoSiretNumber' => 15, 'KataoRcsNumber' => 16, 'KataoCapital' => 17, 'SolAmount' => 18, 'CreatedAt' => 19, 'UpdatedAt' => 20, ),
		BasePeer::TYPE_COLNAME => array (KataoInvoicePeer::ID => 0, KataoInvoicePeer::KATAO_MEMBER_ID => 1, KataoInvoicePeer::KATAO_PERIOD_ID => 2, KataoInvoicePeer::KATAO_NODE_ID => 3, KataoInvoicePeer::KATAO_CART_ID => 4, KataoInvoicePeer::STATUS => 5, KataoInvoicePeer::MEMBER_FIRST_NAME => 6, KataoInvoicePeer::MEMBER_LAST_NAME => 7, KataoInvoicePeer::MEMBER_EMAIL => 8, KataoInvoicePeer::MEMBER_ADDRESS1 => 9, KataoInvoicePeer::MEMBER_ADDRESS2 => 10, KataoInvoicePeer::MEMBER_ZIP => 11, KataoInvoicePeer::MEMBER_CITY => 12, KataoInvoicePeer::KATAO_NAME => 13, KataoInvoicePeer::KATAO_ADDRESS => 14, KataoInvoicePeer::KATAO_SIRET_NUMBER => 15, KataoInvoicePeer::KATAO_RCS_NUMBER => 16, KataoInvoicePeer::KATAO_CAPITAL => 17, KataoInvoicePeer::SOL_AMOUNT => 18, KataoInvoicePeer::CREATED_AT => 19, KataoInvoicePeer::UPDATED_AT => 20, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'katao_member_id' => 1, 'katao_period_id' => 2, 'katao_node_id' => 3, 'katao_cart_id' => 4, 'status' => 5, 'member_first_name' => 6, 'member_last_name' => 7, 'member_email' => 8, 'member_address1' => 9, 'member_address2' => 10, 'member_zip' => 11, 'member_city' => 12, 'katao_name' => 13, 'katao_address' => 14, 'katao_siret_number' => 15, 'katao_rcs_number' => 16, 'katao_capital' => 17, 'sol_amount' => 18, 'created_at' => 19, 'updated_at' => 20, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, )
	);

	/**
	 * @return     MapBuilder the map builder for this peer
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('lib.model.map.KataoInvoiceMapBuilder');
	}
	/**
	 * Gets a map (hash) of PHP names to DB column names.
	 *
	 * @return     array The PHP to DB name map for this peer
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @deprecated Use the getFieldNames() and translateFieldName() methods instead of this.
	 */
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = KataoInvoicePeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	/**
	 * Translates a fieldname to another type
	 *
	 * @param      string $name field name
	 * @param      string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param      string $toType   One of the class type constants
	 * @return     string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param      string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     array A list of field names
	 */

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Convenience method which changes table.column to alias.column.
	 *
	 * Using this method you can maintain SQL abstraction while using column aliases.
	 * <code>
	 *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
	 *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
	 * </code>
	 * @param      string $alias The alias for the current table.
	 * @param      string $column The column name for current table. (i.e. KataoInvoicePeer::COLUMN_NAME).
	 * @return     string
	 */
	public static function alias($alias, $column)
	{
		return str_replace(KataoInvoicePeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	/**
	 * Add all the columns needed to create a new object.
	 *
	 * Note: any columns that were marked with lazyLoad="true" in the
	 * XML schema will not be added to the select list and only loaded
	 * on demand.
	 *
	 * @param      criteria object containing the columns to add.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(KataoInvoicePeer::ID);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_MEMBER_ID);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_PERIOD_ID);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_NODE_ID);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_CART_ID);

		$criteria->addSelectColumn(KataoInvoicePeer::STATUS);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_FIRST_NAME);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_LAST_NAME);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_EMAIL);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_ADDRESS1);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_ADDRESS2);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_ZIP);

		$criteria->addSelectColumn(KataoInvoicePeer::MEMBER_CITY);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_NAME);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_ADDRESS);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_SIRET_NUMBER);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_RCS_NUMBER);

		$criteria->addSelectColumn(KataoInvoicePeer::KATAO_CAPITAL);

		$criteria->addSelectColumn(KataoInvoicePeer::SOL_AMOUNT);

		$criteria->addSelectColumn(KataoInvoicePeer::CREATED_AT);

		$criteria->addSelectColumn(KataoInvoicePeer::UPDATED_AT);

	}

	const COUNT = 'COUNT(katao_invoice.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT katao_invoice.ID)';

	/**
	 * Returns the number of rows matching criteria.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}
	/**
	 * Method to select one object from the DB.
	 *
	 * @param      Criteria $criteria object used to create the SELECT statement.
	 * @param      Connection $con
	 * @return     KataoInvoice
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = KataoInvoicePeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	/**
	 * Method to do selects.
	 *
	 * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param      Connection $con
	 * @return     array Array of selected Objects
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return KataoInvoicePeer::populateObjects(KataoInvoicePeer::doSelectRS($criteria, $con));
	}
	/**
	 * Prepares the Criteria object and uses the parent doSelect()
	 * method to get a ResultSet.
	 *
	 * Use this method directly if you want to just get the resultset
	 * (instead of an array of objects).
	 *
	 * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param      Connection $con the connection to use
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @return     ResultSet The resultset object with numerically-indexed fields.
	 * @see        BasePeer::doSelect()
	 */
	public static function doSelectRS(Criteria $criteria, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectRS:doSelectRS') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $criteria, $con);
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			KataoInvoicePeer::addSelectColumns($criteria);
		}

		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		// BasePeer returns a Creole ResultSet, set to return
		// rows indexed numerically.
		return BasePeer::doSelect($criteria, $con);
	}
	/**
	 * The returned array will contain objects of the default type or
	 * objects that inherit from the default.
	 *
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
		// set the class once to avoid overhead in the loop
		$cls = KataoInvoicePeer::getOMClass();
		$cls = sfPropel::import($cls);
		// populate the object(s)
		while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

	/**
	 * Returns the number of rows matching criteria, joining the related KataoMember table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoMember(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoPeriod table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoPeriod(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoNode table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoNode(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoCart table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinKataoCart(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with their KataoMember objects.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoMember(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoMemberPeer::addSelectColumns($c);

		$c->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoMemberPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoMember(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoInvoice($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with their KataoPeriod objects.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoPeriod(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoPeriodPeer::addSelectColumns($c);

		$c->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoPeriodPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoInvoice($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with their KataoNode objects.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoNode(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoNodePeer::addSelectColumns($c);

		$c->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoNodePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoInvoice($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with their KataoCart objects.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinKataoCart(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		KataoCartPeer::addSelectColumns($c);

		$c->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoCartPeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getKataoCart(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					// e.g. $author->addBookRelatedByBookId()
					$temp_obj2->addKataoInvoice($obj1); //CHECKME
					break;
				}
			}
			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1); //CHECKME
			}
			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Returns the number of rows matching criteria, joining all related tables
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, $con = null)
	{
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with all related objects.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoinAll:doSelectJoinAll') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol2 = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoMemberPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoMemberPeer::NUM_COLUMNS;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoPeriodPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol5 = $startcol4 + KataoNodePeer::NUM_COLUMNS;

		KataoCartPeer::addSelectColumns($c);
		$startcol6 = $startcol5 + KataoCartPeer::NUM_COLUMNS;

		$c->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);

		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);


				// Add objects for joined KataoMember rows
	
			$omClass = KataoMemberPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoMember(); // CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoInvoice($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1);
			}


				// Add objects for joined KataoPeriod rows
	
			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoPeriod(); // CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoInvoice($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoInvoices();
				$obj3->addKataoInvoice($obj1);
			}


				// Add objects for joined KataoNode rows
	
			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj4 = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getKataoNode(); // CHECKME
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addKataoInvoice($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj4->initKataoInvoices();
				$obj4->addKataoInvoice($obj1);
			}


				// Add objects for joined KataoCart rows
	
			$omClass = KataoCartPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj5 = new $cls();
			$obj5->hydrate($rs, $startcol5);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj5 = $temp_obj1->getKataoCart(); // CHECKME
				if ($temp_obj5->getPrimaryKey() === $obj5->getPrimaryKey()) {
					$newObject = false;
					$temp_obj5->addKataoInvoice($obj1); // CHECKME
					break;
				}
			}

			if ($newObject) {
				$obj5->initKataoInvoices();
				$obj5->addKataoInvoice($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoMember table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoMember(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoPeriod table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoPeriod(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoNode table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoNode(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Returns the number of rows matching criteria, joining the related KataoCart table
	 *
	 * @param      Criteria $c
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCountJoinAllExceptKataoCart(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(KataoInvoicePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$criteria->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$rs = KataoInvoicePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with all related objects except KataoMember.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoMember(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol2 = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoPeriodPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoNodePeer::NUM_COLUMNS;

		KataoCartPeer::addSelectColumns($c);
		$startcol5 = $startcol4 + KataoCartPeer::NUM_COLUMNS;

		$c->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1);
			}

			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoInvoices();
				$obj3->addKataoInvoice($obj1);
			}

			$omClass = KataoCartPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj4  = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getKataoCart(); //CHECKME
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj4->initKataoInvoices();
				$obj4->addKataoInvoice($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with all related objects except KataoPeriod.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoPeriod(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol2 = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoMemberPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoMemberPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoNodePeer::NUM_COLUMNS;

		KataoCartPeer::addSelectColumns($c);
		$startcol5 = $startcol4 + KataoCartPeer::NUM_COLUMNS;

		$c->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoMemberPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoMember(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1);
			}

			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoInvoices();
				$obj3->addKataoInvoice($obj1);
			}

			$omClass = KataoCartPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj4  = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getKataoCart(); //CHECKME
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj4->initKataoInvoices();
				$obj4->addKataoInvoice($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with all related objects except KataoNode.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoNode(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol2 = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoMemberPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoMemberPeer::NUM_COLUMNS;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoPeriodPeer::NUM_COLUMNS;

		KataoCartPeer::addSelectColumns($c);
		$startcol5 = $startcol4 + KataoCartPeer::NUM_COLUMNS;

		$c->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_CART_ID, KataoCartPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoMemberPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoMember(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1);
			}

			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoInvoices();
				$obj3->addKataoInvoice($obj1);
			}

			$omClass = KataoCartPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj4  = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getKataoCart(); //CHECKME
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj4->initKataoInvoices();
				$obj4->addKataoInvoice($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	/**
	 * Selects a collection of KataoInvoice objects pre-filled with all related objects except KataoCart.
	 *
	 * @return     array Array of KataoInvoice objects.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptKataoCart(Criteria $c, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doSelectJoinAllExcept:doSelectJoinAllExcept') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $c, $con);
    }


		$c = clone $c;

		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		KataoInvoicePeer::addSelectColumns($c);
		$startcol2 = (KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		KataoMemberPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + KataoMemberPeer::NUM_COLUMNS;

		KataoPeriodPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + KataoPeriodPeer::NUM_COLUMNS;

		KataoNodePeer::addSelectColumns($c);
		$startcol5 = $startcol4 + KataoNodePeer::NUM_COLUMNS;

		$c->addJoin(KataoInvoicePeer::KATAO_MEMBER_ID, KataoMemberPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_PERIOD_ID, KataoPeriodPeer::ID);

		$c->addJoin(KataoInvoicePeer::KATAO_NODE_ID, KataoNodePeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = KataoInvoicePeer::getOMClass();

			$cls = sfPropel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = KataoMemberPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getKataoMember(); //CHECKME
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initKataoInvoices();
				$obj2->addKataoInvoice($obj1);
			}

			$omClass = KataoPeriodPeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getKataoPeriod(); //CHECKME
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initKataoInvoices();
				$obj3->addKataoInvoice($obj1);
			}

			$omClass = KataoNodePeer::getOMClass();


			$cls = sfPropel::import($omClass);
			$obj4  = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getKataoNode(); //CHECKME
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addKataoInvoice($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj4->initKataoInvoices();
				$obj4->addKataoInvoice($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


  static public function getUniqueColumnNames()
  {
    return array();
  }
	/**
	 * Returns the TableMap related to this peer.
	 * This method is not needed for general use but a specific application could have a need.
	 * @return     TableMap
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	/**
	 * The class that the Peer will make instances of.
	 *
	 * This uses a dot-path notation which is tranalted into a path
	 * relative to a location on the PHP include_path.
	 * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
	 *
	 * @return     string path.to.ClassName
	 */
	public static function getOMClass()
	{
		return KataoInvoicePeer::CLASS_DEFAULT;
	}

	/**
	 * Method perform an INSERT on the database, given a KataoInvoice or Criteria object.
	 *
	 * @param      mixed $values Criteria or KataoInvoice object containing data that is used to create the INSERT statement.
	 * @param      Connection $con the connection to use
	 * @return     mixed The new primary key.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doInsert($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doInsert:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseKataoInvoicePeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity
		} else {
			$criteria = $values->buildCriteria(); // build Criteria from KataoInvoice object
		}

		$criteria->remove(KataoInvoicePeer::ID); // remove pkey col since this table uses auto-increment


		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		try {
			// use transaction because $criteria could contain info
			// for more than one table (I guess, conceivably)
			$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		
    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doInsert:post') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $values, $con, $pk);
    }

    return $pk;
	}

	/**
	 * Method perform an UPDATE on the database, given a KataoInvoice or Criteria object.
	 *
	 * @param      mixed $values Criteria or KataoInvoice object containing data that is used to create the UPDATE statement.
	 * @param      Connection $con The connection to use (specify Connection object to exert more control over transactions).
	 * @return     int The number of affected rows (if supported by underlying database driver).
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doUpdate($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doUpdate:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseKataoInvoicePeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity

			$comparison = $criteria->getComparison(KataoInvoicePeer::ID);
			$selectCriteria->add(KataoInvoicePeer::ID, $criteria->remove(KataoInvoicePeer::ID), $comparison);

		} else { // $values is KataoInvoice object
			$criteria = $values->buildCriteria(); // gets full criteria
			$selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
		}

		// set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		$ret = BasePeer::doUpdate($selectCriteria, $criteria, $con);
	

    foreach (sfMixer::getCallables('BaseKataoInvoicePeer:doUpdate:post') as $callable)
    {
      call_user_func($callable, 'BaseKataoInvoicePeer', $values, $con, $ret);
    }

    return $ret;
  }

	/**
	 * Method to DELETE all rows from the katao_invoice table.
	 *
	 * @return     int The number of affected rows (if supported by underlying database driver).
	 */
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; // initialize var to track total num of affected rows
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			$affectedRows += BasePeer::doDeleteAll(KataoInvoicePeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Method perform a DELETE on the database, given a KataoInvoice or Criteria object OR a primary key value.
	 *
	 * @param      mixed $values Criteria or KataoInvoice object or primary key or array of primary keys
	 *              which is used to create the DELETE statement
	 * @param      Connection $con the connection to use
	 * @return     int 	The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
	 *				if supported by native driver or if emulated using Propel.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(KataoInvoicePeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity
		} elseif ($values instanceof KataoInvoice) {

			$criteria = $values->buildPkeyCriteria();
		} else {
			// it must be the primary key
			$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(KataoInvoicePeer::ID, (array) $values, Criteria::IN);
		}

		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; // initialize var to track total num of affected rows

		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Validates all modified columns of given KataoInvoice object.
	 * If parameter $columns is either a single column name or an array of column names
	 * than only those columns are validated.
	 *
	 * NOTICE: This does not apply to primary or foreign keys for now.
	 *
	 * @param      KataoInvoice $obj The object to validate.
	 * @param      mixed $cols Column name or array of column names.
	 *
	 * @return     mixed TRUE if all columns are valid or the error message of the first invalid column.
	 */
	public static function doValidate(KataoInvoice $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(KataoInvoicePeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(KataoInvoicePeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(KataoInvoicePeer::DATABASE_NAME, KataoInvoicePeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = KataoInvoicePeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	/**
	 * Retrieve a single object by pkey.
	 *
	 * @param      mixed $pk the primary key.
	 * @param      Connection $con the connection to use
	 * @return     KataoInvoice
	 */
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(KataoInvoicePeer::DATABASE_NAME);

		$criteria->add(KataoInvoicePeer::ID, $pk);


		$v = KataoInvoicePeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	/**
	 * Retrieve multiple objects by pkey.
	 *
	 * @param      array $pks List of primary keys
	 * @param      Connection $con the connection to use
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(KataoInvoicePeer::ID, $pks, Criteria::IN);
			$objs = KataoInvoicePeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} // BaseKataoInvoicePeer

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
	// the MapBuilder classes register themselves with Propel during initialization
	// so we need to load them here.
	try {
		BaseKataoInvoicePeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
	// even if Propel is not yet initialized, the map builder class can be registered
	// now and then it will be loaded when Propel initializes.
	Propel::registerMapBuilder('lib.model.map.KataoInvoiceMapBuilder');
}
